import { LoggerService } from "@nestjs/common";
import express from "express";
import pino, { LoggerOptions, DestinationStream } from "pino";
export declare class Logger implements LoggerService {
    verbose(msg: string, ...args: any[]): void;
    verbose(obj: object, msg?: string, ...args: any[]): void;
    debug(msg: string, ...args: any[]): void;
    debug(obj: object, msg?: string, ...args: any[]): void;
    log(msg: string, ...args: any[]): void;
    log(obj: object, msg?: string, ...args: any[]): void;
    warn(msg: string, ...args: any[]): void;
    warn(obj: object, msg?: string, ...args: any[]): void;
    error(msg: string, ...args: any[]): void;
    error(obj: object, msg?: string, ...args: any[]): void;
}
declare type PassedLogger = {
    logger: pino.Logger;
};
export declare function createLoggerMiddlewares(): express.Handler[];
export declare function createLoggerMiddlewares(options: PassedLogger): express.Handler[];
export declare function createLoggerMiddlewares(optionsOrStream: LoggerOptions | DestinationStream): express.Handler[];
export declare function createLoggerMiddlewares(options: LoggerOptions, stream: DestinationStream): express.Handler[];
declare global {
    namespace Express {
        interface Request {
            log: pino.Logger;
        }
    }
}
export {};
